# Pull Request Template

## Description
Please include a summary of the change and which issue is fixed. Please also include relevant motivation and context. List any dependencies that are required for this change.

## Type of change

- [ ] Bug fix (non-breaking change which fixes an issue)
- [ ] New feature (non-breaking change which adds functionality)
- [ ] Breaking change (fix or feature that would cause existing functionality not to work as expected)
- [ ] This change requires a documentation update

## User Impact
Please describe the impact of this change. This can be a list of positive and/or negative impacts.

## Performance Impact
Please describe any relevant performance impact of this change. This can be positive or negative impact. How did you characterize/test the performance impact?

## How Has This Been Tested?
Please describe the tests that you ran to verify your changes. Provide instructions so we can reproduce. Please also list any relevant details for your test configuration.
- [ ] Test A
- [ ] Test B

**Hardware Configuration**:
* Development Kit: 
* Module or Chip Used: 
* Debug Adapter: 

**Software Configuration**:
* OpenOCD version: 
* Branch:
* ESP_IDF version:
* Operating System:

## Checklist:
- [ ] My code follows the style guidelines of this project
- [ ] I have performed a self-review of my own code
- [ ] I have commented my code, particularly in hard-to-understand areas
- [ ] My changes generate no new warnings